Loading...
Searching...
No Matches
Sip_max_forwards

## Data Structures

struct | sip_max_forwards_s
| Structure for Max-Forwards header. More...

## Macros

#define | sip_max_forwards(sip)
| Access a SIP Max-Forwards header structure sip_max_forwards_t from sip_t.
#define | SIP_MAX_FORWARDS_INIT()
| Initializer for structure sip_max_forwards_t.
#define | SIPTAG_MAX_FORWARDS(x)
| Tag list item for pointer to a Max-Forwards header structure sip_max_forwards_t.
#define | SIPTAG_MAX_FORWARDS_REF(x)
| Tag list item for reference to a Max-Forwards header pointer.
#define | SIPTAG_MAX_FORWARDS_STR(s)
| Tag list item for string with Max-Forwards header value.
#define | SIPTAG_MAX_FORWARDS_STR_REF(x)
| Tag list item for reference to a Max-Forwards header string.

## Typedefs

typedef struct sip_max_forwards_s | sip_max_forwards_t
| @

## Functions

issize_t | sip_max_forwards_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Max-Forwards header.
issize_t | sip_max_forwards_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Max-Forwards header.
sip_max_forwards_t * | sip_max_forwards_init (sip_max_forwards_t x[1])
| Initialize a structure sip_max_forwards_t.
int | sip_is_max_forwards (sip_header_t const *header)
| Test if header object is instance of sip_max_forwards_t.
sip_max_forwards_t * | sip_max_forwards_dup (su_home_t *home, sip_max_forwards_t const *hdr))
| Duplicate a list of Max-Forwards header header structures sip_max_forwards_t.
sip_max_forwards_t * | sip_max_forwards_copy (su_home_t *home, sip_max_forwards_t const *hdr))
| Copy a list of Max-Forwards header header structures sip_max_forwards_t.
sip_max_forwards_t * | sip_max_forwards_make (su_home_t *home, char const *s))
| Make a Max-Forwards header structure sip_max_forwards_t.
sip_max_forwards_t * | sip_max_forwards_format (su_home_t *home, char const *fmt,...)))
| Make a Max-Forwards header from formatting result.

## Variables

msg_hclass_t | sip_max_forwards_class []
| Header class for Max-Forwards header.
tag_typedef_t | siptag_max_forwards
| Tag for Max-Forwards header object.
tag_typedef_t | siptag_max_forwards_str
| Tag for string with Max-Forwards header value.

## Detailed Description

## Macro Definition Documentation

## SIP_MAX_FORWARDS_INIT

#define SIP_MAX_FORWARDS_INIT | ( |  | ) |

Initializer for structure sip_max_forwards_t.

A static sip_max_forwards_t structure for Max-Forwards header must be initialized with the SIP_MAX_FORWARDS_INIT() macro. For instance,

sip_max_forwards_t sip_max_forwards = SIP_MAX_FORWARDS_INIT;
sip_max_forwards_t
struct sip_max_forwards_s sip_max_forwards_t
@
Definition sip.h:162
sip_max_forwards
#define sip_max_forwards(sip)
Access a SIP Max-Forwards header structure sip_max_forwards_t from sip_t.
Definition sip_protos.h:1321
SIP_MAX_FORWARDS_INIT
#define SIP_MAX_FORWARDS_INIT()
Initializer for structure sip_max_forwards_t.
Definition sip_protos.h:1338

## SIPTAG_MAX_FORWARDS

#define SIPTAG_MAX_FORWARDS | ( |  | x | ) |

Tag list item for pointer to a Max-Forwards header structure sip_max_forwards_t.

The SIPTAG_MAX_FORWARDS() macro is used to include a tag item with a pointer to a sip_max_forwards_t structure in a tag list.

Parameters

  x | pointer to a sip_max_forwards_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_MAX_FORWARDS_REF().

## SIPTAG_MAX_FORWARDS_STR

#define SIPTAG_MAX_FORWARDS_STR | ( |  | s | ) |

Tag list item for string with Max-Forwards header value.

The SIPTAG_MAX_FORWARDS_STR() macro is used to include a tag item with a string containing value of a sip_max_forwards_t header in a tag list.

Parameters

  s | pointer to a string containing Max-Forwards header value, or NULL.

The string in SIPTAG_MAX_FORWARDS_STR() can be converted to a sip_max_forwards_t header structure by giving the string s has second argument to function sip_max_forwards_make().

The corresponding tag taking reference parameter is SIPTAG_MAX_FORWARDS_STR_REF().

## Typedef Documentation

## sip_max_forwards_t

typedef struct sip_max_forwards_s sip_max_forwards_t

@

The Max-Forwards header is used to limit the number of proxies or gateways that can forward the request. The Max-Forwards syntax is defined in RFC 3261 as follows:

Max-Forwards = "Max-Forwards" HCOLON 1*DIGIT
DIGIT
#define DIGIT

The parsed Max-Forwards header is stored in sip_max_forwards_t structure.

The structure sip_max_forwards_t contains representation of SIP Max-Forwards header.

The sip_max_forwards_t is defined as follows:

typedef struct sip_max_forwards_s {
sip_common_t mf_common[1]; // Common fragment info
sip_error_t *mf_next; // Link to next (dummy)
unsigned long mf_count; // Digits
} sip_max_forwards_t;
sip_error_t
msg_error_t sip_error_t
@
Definition sip.h:134
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_max_forwards_s
Structure for Max-Forwards header.
Definition sip.h:559
sip_max_forwards_s::mf_common
sip_common_t mf_common[1]
Common fragment info.
Definition sip.h:560
sip_max_forwards_s::mf_next
sip_error_t * mf_next
Link to next (dummy).
Definition sip.h:561
sip_max_forwards_s::mf_count
unsigned long mf_count
Forwarding count.
Definition sip.h:562

## Function Documentation

## sip_is_max_forwards()

int sip_is_max_forwards | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_max_forwards_t.

Check if the header class is an instance of Max-Forwards header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header max_forwards
  0 | (false) otherwise

## sip_max_forwards_copy()

sip_max_forwards_t * sip_max_forwards_copy | ( | su_home_t * | home,
|  | sip_max_forwards_t const * | hdr )

inline

Copy a list of Max-Forwards header header structures sip_max_forwards_t.

The function sip_max_forwards_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  max_forwards = sip_max_forwards_copy(home, sip->sip_max_forwards);
  sip_max_forwards_copy
  sip_max_forwards_t * sip_max_forwards_copy(su_home_t *home, sip_max_forwards_t const *hdr))
  Copy a list of Max-Forwards header header structures sip_max_forwards_t.
  Definition sip_protos.h:1468

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_max_forwards_dup()

sip_max_forwards_t * sip_max_forwards_dup | ( | su_home_t * | home,
|  | sip_max_forwards_t const * | hdr )

inline

Duplicate a list of Max-Forwards header header structures sip_max_forwards_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  max_forwards = sip_max_forwards_dup(home, sip->sip_max_forwards);
  sip_max_forwards_dup
  sip_max_forwards_t * sip_max_forwards_dup(su_home_t *home, sip_max_forwards_t const *hdr))
  Duplicate a list of Max-Forwards header header structures sip_max_forwards_t.
  Definition sip_protos.h:1425

Returns
  A pointer to the newly duplicated sip_max_forwards_t header structure, or NULL upon an error.

## sip_max_forwards_format()

sip_max_forwards_t * sip_max_forwards_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Max-Forwards header from formatting result.

Make a new sip_max_forwards_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_max_forwards_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_max_forwards_init()

sip_max_forwards_t * sip_max_forwards_init | ( | sip_max_forwards_t | x[1] | ) |

inline

Initialize a structure sip_max_forwards_t.

An sip_max_forwards_t structure for Max-Forwards header can be initialized with the sip_max_forwards_init() function/macro. For instance,

sip_max_forwards_t sip_max_forwards;
sip_max_forwards_init(&sip_max_forwards);
sip_max_forwards_init
sip_max_forwards_t * sip_max_forwards_init(sip_max_forwards_t x[1])
Initialize a structure sip_max_forwards_t.
Definition sip_protos.h:1356

## sip_max_forwards_make()

sip_max_forwards_t * sip_max_forwards_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Max-Forwards header structure sip_max_forwards_t.

The function sip_max_forwards_make() makes a new sip_max_forwards_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_max_forwards_t header structure, or NULL upon an error.

## Variable Documentation

## sip_max_forwards_class

msg_hclass_t sip_max_forwards_class[]

extern

Header class for Max-Forwards header.

The header class sip_max_forwards_class defines how a SIP Max-Forwards header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_max_forwards_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.